//Coding HTML Page
const char CODING_page [] PROGMEM = R"====(

<h2><label  id ="pagetitle">Pixel Controller - Coding</label></h2>


<!--***Start of Message Table-->
<h4><table><tr><th style = 'width: 480px' > Messages. </th></tr>
<tr><td><span id = "message">Message</span></td></tr>
</table></h4>
<!--***Start of Controls -->
<h4>
<table>
<tr>
<td><button type = "button" onclick = "ClientToServer('back')" id = 'cbut0'>Home</button></td>
<td><button type = "button" onclick = "sendCText()" id = 'cbut1'>Save and Run</button></td>
<td><button type = "button" onclick = "ClientToServer('csetspare')" id = 'cbut2'>Set to Spare</button></td>
<td><button type = "button" onclick = "ClientToServer('codingexport')" id = 'cbut3'>Export Coding</button></td>
</tr>
</table>

<!--***Coding List -->
<br>
<label for = 'codinglistlabel'>Coding List: </label>
<select id='codinglist' onChange="SendCodingIndex()">
</select>
<br>
<script>
function SendCodingIndex(){ClientToServer("codinglistindex=" + document.getElementById("codinglist").value);}
</script>
<script><!-- THIS MAY NOT BE NECESSARY-->
     addC =document.getElementById('codinglist');
     for (var i= 0;i<15;i++ )
     {
      dOption =document.createElement('option');
      dOption.text= "Buttonx " + (i +1) ;
      dOption.value = i ;
      addC.add(dOption);
     }
</script>

<!--***Design/Icons List-->
<br>
<label for = 'designlistlabel'>Design/Icon List: </label>
<select id='designlist' onChange="SendDesignIndex()">
</select>
<br><br>
<script>
function SendDesignIndex(){ClientToServer("designlistindex=" + document.getElementById("designlist").value);}
</script>
<script><!-- THIS MAY NOT BE NECESSARY-->
     addD =document.getElementById('designlist');
     for (var i= 0;i<150;i++ )
     {
      dLOption =document.createElement('option');
      dLOption.text= "Design " + (i +1) ;
      dLOption.value = i ;
      addD.add(dLOption);
     }
</script>

<!--***Coding Window -->
<label for='codingtextlabel'>Coding Window: Button: <span id = "codingindex"></span></label>
<label for='codinglengthlabel'>Code Length:<span id ="codinglength"></span></label>
<br>
<textarea id= "codingtext" name='ct' rows='12' cols='35' spellcheck='false'></textarea>
<br>
<br>

<br>

<!--***Coding Help --> 
<label for='codinghelp'>Coding Syntax Help:</label><br>
<textarea id="codinghelp" name='ch'  rows='35' cols='75' spellcheck='false'>
*Code Name:    <N> Name
*Label:        <L> Button label
*Action:       <A> Scroll, Spell, Letter, Game, Icon or Ani
*Text:         <T> Text, Letter, Icon Name or Icon Range
                   Icon Name(eg <T>House),  Icon Range(eg <T>I20I25)
                   or Design Range(eg <T>D20D25)
                   Game Name(eg <T>Invaders or <T>Pong)
BrIghtness:   <I>20 to 100 (Percent- Lower values may not be visible.)
colour Red:   <R>0 to 100
colour Green: <G>0 to 100
colour Blue:  <B>0 to 100
Red Random:   <RR>0 to 100
Green Random: <GR>0 to 100
Blue Random:  <BR>0 to 100
Fade:         <F>Yes or No

Note 1. * Denotes mandatory entry. 
Note 2. Ani means Animation.
Note 3. If an Icon/Design is used in the Text Field then
the Pixel Colours are set and fixed in the Design View for that Item
Note 4. Games are Invaders or Pong. 
Note 5. Sample Coding Entry could be as follows: 
First, Select the required Coding Button (0 to 14) from the Coding List.
Then populate the Coding Window using the Mandatory and Optional Tags as follows:
<N>Button x
<L>Run Animation
<A>Ani
<T>D10D20
Then press Save and Run Button.
</textarea>
<!-- document.getElementById("codinghelp").value = x;-->
<!--</script>-->

<script>
function sendCText()
{
 ClientToServer("ctext=" + document.getElementById("codingtext").value);
}
</script>

<!--*** Web Socket Connection -->
<script>
var connection = 
new WebSocket('ws://'+location.hostname+':81/', ['arduino']);

<!--*** Client to Server Data -->
function ClientToServer(out) 
{
  connection.send(out + ":");
  if (out =="back")
  {
      location.reload();
  }
}
<!--*** Server to Client Data -->
connection.onmessage = function (state) 
{
    var str=state.data.split("~");
        var htmlMode = str[0];
        if (str[1] == "1")
        {
        document.getElementById("pagetitle").innerHTML = str[2];
        document.getElementById("message").innerHTML = str[3];
        document.getElementById("codingindex").innerHTML = str[7];
        document.getElementById("codingtext").value =str[8];
        cDetails = str[8];
        var cLength = cDetails.length;
        document.getElementById('codinglength').innerHTML = cLength + " /100 ";   
         
        <!--RE-DO THE CODING LIST-->
        var cL  =document.getElementById('codinglist');
        var i, L = cL.options.length - 1;
        for(i = L; i >= 0; i--) 
                {
                  cL.remove(i);
                }
        for (var i= 0;i<15;i++)
                {
                  iOption =document.createElement('option');
                  iOption.text =  "Button " + (i) + " - " + str[i+10];
                  iOption.value = i;
                  cL.add(iOption);
                }
        document.getElementById("codinglist").selectedIndex = str[7];
        
          <!--RE-DO THE DESIGN/ICON LIST-->
        var dL  =document.getElementById('designlist');
        var i, L = dL.options.length - 1;
        for(i = L; i >= 0; i--) 
                {
                  dL.remove(i);
                }
        for (var i= 0;i<175;i++)
                {
                  iOption =document.createElement('option');
                  iOption.text =   str[i+25];
                  iOption.value = i;
                  dL.add(iOption);
                }
              
        }
}
  

</script>
</body>
</html>
)====";
